//RenMerge0307
/*Holds all of the comments for the application done in review*/
var appReviewComments;
var reviewersComments = [];
var adminCollection;
var reviewerCollection;

function selectToolbar(targetState) {
	var tempReviewers = new HashSet();

	function gatherReviewers(list) {
		var i;
		if (list != null) {
			for (i = 0; i < list.results.length; i++)
				tempReviewers.add(list.results[i]);
		}
	};
	gatherReviewers(spAppData[RAMS.Environment.SharePoint.List.Application.PrimaryReviewersId]);
	gatherReviewers(spAppData.ReviewersId);

	groupCheck(function(committeeMember, irbAdmin){ //add liaison.
		//console.log("receiving: committee Member " + committeeMember + ", irbAdmin " + irbAdmin);
		/*initializing toolbars and r/w access*/

		var cIRBCollection;
		sendREST("GET", siteUrl.concat("_api/Web/SiteGroups(34)/Users"), null, function(cirbAdmins){
			cIRBCollection = buildUsers(cirbAdmins);
			console.log("length of CIRB collection:"+cIRBCollection.length);
		});

		if (currentUser.Id == spAppData[RAMS.Environment.SharePoint.List.Application.PrincipalInvestigatorId]) {
			//console.log("you are the PI");
			if((targetState == 1) || (targetState == 3)){
				generatePITool();
				readOnlyState = false;
			}else if((currentFormType == "Parent") && (targetState >= 4)){
				generateApprovedTools();
			}
		//}else if(cIRBCollection.contains(currentUser.Id)){ 			/*** FIX ***/
			//if((targetState != 1) && (targetState != 3)){
				//generateCIRBAdminTool();
			//}
		}else if(((spAppData[RAMS.Environment.SharePoint.List.Application.PrimaryReviewersId] != null) && (currentUser.Id == spAppData[RAMS.Environment.SharePoint.List.Application.PrimaryReviewersId].results[0])) || (tempReviewers.contains(currentUser.Id))){
			//console.log("you are a reviewer or the primary reviewer");
			if(targetState == 2 || targetState == 4){
				generateReviewerTool();
			}
		}else if(currentUser.Id == spAppData.AssignedIRBAdministratorId){
			//reviewers should always be in a read only state
			//console.log("you are the assigned IRB Admin");
			if((targetState != 1) && (targetState != 3)){
				generateIRBAdminTool();
			}
		}else if(studyMembers.contains(currentUser.Id)){
			//console.log("you are a study member");
			if((targetState == 1) || (targetState == 3)){
				generateStudyTool();
				readOnlyState = false;
			}
		}else if(irbAdmin == true){
			//should really check if the person is in the site's irb admin group...
			//console.log("you are an IRB Admin");
			if((targetState != 1) && (targetState != 3)){
				generateAssignTool();
				//generateLocalSiteTool();
			}
		}else if(cIRBCollection.contains(currentUser.Id)){ 			/*** FIX ***/
			if((targetState != 1) && (targetState != 3)){
				generateCIRBAdminTool();
			}
		}else if(committeeMember == true){
			//console.log("you are a committeeMember");
		}
	});

	// if(readOnlyState){
	// 	console.log("you should be in a read only state");
	// }
};

/*encompases the basic toolbar structure and
specialized buttons that an IRB Admin would see.
Also pre-generates the assignments tab since it's the
first button*/
function generateIRBAdminTool(){
	//console.log("irb admin tool generation");

	generateToolStructure("Assigned IRB Admin Toolbar");

	swapToolGenerator("assignApp");
};

function generateStudyTool(){
	generateToolStructure("Study Member Toolbar");

	swapToolGenerator("studyComments");
};

function generatePITool(){
	generateToolStructure("PI Toolbar");

	swapToolGenerator("piComments");
};

function generateApprovedTools(){
	generateToolStructure("Approved Toolbar");

	swapToolGenerator("postApproveEvents");
};

function generateAssignTool(){
	generateToolStructure("General IRB Admin Toolbar");

	swapToolGenerator("assignIRBAdmin")
};

function generateReviewerTool(){
	generateToolStructure("Reviewer Toolbar");

	swapToolGenerator("reviewComments");
}

/********************************************************************/
function generateLocalSiteTool(){
	generateToolStructure("Local Site Liaison Toolbar");

	swapToolGenerator("localSite");
}

function generateCIRBAdminTool(){
	generateToolStructure("cIRB Admin Toolbar");

	swapToolGenerator("CIRBAdmin");
}
/********************************************************************/

function swapToolGenerator(targetTool){
	var row, secondPanel;

	$('#built-tool').remove();

	row = document.createElement("row");
	row.setAttribute("class", "row");
	row.setAttribute("id", "built-tool");

	if(targetTool == "assignApp"){
		/*assignments tab*/	
		sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(groupJSON){
			var currentGroups = groupJSON.d.results;
			var adminGroupID = -1;
			var siteUsersGroupID = -1;
			
	        for(var i=0; i<currentGroups.length; i++){ //find the admin group and site users' group for the user's site
	            if(currentGroups[i].Title.indexOf("Administrators") > -1){
	                adminGroupID = currentGroups[i].Id;
	            }
	            else if(currentGroups[i].Title.indexOf("Users") > -1){
	                siteUsersGroupID = currentGroups[i].Id;
	            }
	        }
	        
	        //perform REST calls if we have values
	        if((adminGroupID > 0) && (siteUsersGroupID > 0)){ //assuming we only need the admins from one site
				sendREST("GET", siteUrl.concat("_api/Web/SiteGroups("+adminGroupID+")/Users"), null, function(irbAdmins){
					sendREST("GET", siteUrl.concat("_api/Web/SiteGroups("+siteUsersGroupID+")/Users"), null, function(siteUsers){
						sendREST("GET", restPath.concat("study/"+assignedID+"/members"), null, function(studyMember){
							var studyMemberNames = [];
							var availableReviewers = [];
							
							for (var j=0; j<studyMember.length; j++){
								studyMemberNames.push(studyMember[j].user.displayName);
							}
							
							//parse JSON and extract names
							var userCollection = buildUsers(siteUsers); 
							var tempCollection = userCollection.values();
							for(var i=0; i<tempCollection.length; i++){ //filter out study members from reviewer group
								if(studyMemberNames.indexOf(tempCollection[i].Title) == -1) 
									availableReviewers.push(tempCollection[i].Title);
							}
							row.appendChild(buildAdminSelecters(irbAdmins, availableReviewers));
							row.appendChild(buildAdminReviewers());
							row.appendChild(generateToolTabs(targetTool));
						});	
					});
				});
	        }
		});
	}else if(targetTool == "appReview"){
		/*review tab*/		
		if(validSection.length == 0)
			window.setTimeout(function(){swapToolGenerator(targetTool)}, 2000);
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){			
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildAdminComments());
			row.appendChild(buildReviewersComments());
			row.appendChild(generateToolTabs(targetTool));
		});
	}else if(targetTool == "appChecklists"){
		/*checklists tab*/
		sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('SiteAssets/IRB Admin Checklists')/Files"), null, function(checklists){
			sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Review%20Team')/Files"), null, function(returnedFiles){
				row.appendChild(buildChecklistTemplates(checklists.d.results));
				row.appendChild(buildUploadedChecklists(returnedFiles.d.results, "Review%20Team"));
				row.appendChild(generateToolTabs(targetTool));
			});
		});
	}else if(targetTool == "submitApp"){
		/*approve tab*/
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){		
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildSubmitComments(["Re-Submit to Study Team", "Approve Application", "Approve with Minor Modifications", "Approve with Major Modifications", "Suspend", "Rejected"]));
			row.appendChild(buildAppHistory());
			row.appendChild(generateToolTabs(targetTool));
		});
	}else if(targetTool == "appEvent"){
		/*events tab*/
		//row.appendChild(buildAddEvent("Review Team", "1"));
		row.appendChild(buildPostApproveReview());
		row.appendChild(buildEventHistory());
		row.appendChild(generateToolTabs(targetTool));
	}else if(targetTool == "studyComments"){
		/*study member's comments tab*/
		if(validSection.length == 0)
			window.setTimeout(function(){swapToolGenerator(targetTool)}, 2000);
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildAdminComments());
			row.appendChild(buildReviewersComments());
			row.appendChild(generateStudyToolTabs(targetTool));
		});
	}else if(targetTool == "postApproveEvents"){
		/*Possible events post-approval*/
		row.appendChild(buildAddEvent());
		row.appendChild(buildEventHistory());
	}else if(targetTool == "piChecklists"){
		sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('SiteAssets/PI Checklists')/Files"), null, function(checklists){
			sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Study%20Team')/Files"), null, function(returnedFiles){
				studyChecklists = filterChecklists(returnedFiles.d.results, "-CHECKLIST-");
				row.appendChild(buildChecklistTemplates(checklists.d.results));
				row.appendChild(buildUploadedChecklists(studyChecklists, "Study%20Team"));
				row.appendChild(generatePIToolTabs(targetTool));
			});
		});
	}else if(targetTool == "piComments"){
		if(validSection.length == 0)
			window.setTimeout(function(){swapToolGenerator(targetTool)}, 2000);
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildAdminComments());
			row.appendChild(buildReviewersComments());
			row.appendChild(generatePIToolTabs(targetTool));
		});
	}else if(targetTool == "piSubmitApp"){
		/*review tab*/		
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){		
		commentsRollup(targetStage, function(comments){
			mapComments(comments);
			row.appendChild(buildSubmitComments(["Re-Submit for Review"]));
			row.appendChild(buildAppHistory());
			row.appendChild(generatePIToolTabs(targetTool));
		});
	}else if(targetTool == "assignIRBAdmin"){
		sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(groupJSON){
			var currentGroups = groupJSON.d.results;
			var adminGroupID = -1;
			var tempCollection;
			var targetTool = "assignIRBAdmin"; //set default targetTool
			
	        for(var i=0; i<currentGroups.length; i++){ //find the admin group for the user's site
	            if(currentGroups[i].Title.indexOf("Administrators") > -1){
	                adminGroupID = currentGroups[i].Id;
	            }
	        }
	        if(adminGroupID > 0){ //assuming we only need the admins from one site
				sendREST("GET", siteUrl.concat("_api/Web/SiteGroups("+adminGroupID+")/Users"), null, function(irbAdmins){
					
					//check for size of IRB Admin group
					adminCollection = buildUsers(irbAdmins); //parse the JSON data for administrators, using global variable
					tempCollection = adminCollection.values();
					
					if (tempCollection.length == 1){
						if(tempCollection[0].Title == currentUser.Title){ //if current user admin, give them assigned toolbar
							targetTool = "assignApp";
						}
						var intoReview = (targetTool === "assignIRBAdmin"); //boolean value
						data = {
							"__metadata": spAppData.__metadata,
							"AssignedIRBAdministratorId": tempCollection[0].Id
						};
						spAppData.AssignedIRBAdministratorId = tempCollection[0].Id;
						if (intoReview)
							data.ApplicationStatus = spAppData.ApplicationStatus = "Under Review";
						
						//send admin data in POST REST calls
						sendREST("POST", spAppData.__metadata.uri, data, function(){
							sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){	
								var finishUp = function() {
									insertStudyMember(tempCollection[0].Title, "RAMS Reviewer", false);
									swapToolGenerator(targetTool);
								};
								
								if (!intoReview) {
									finishUp();
								}else {
									sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, finishUp);
								}
							}, "Merge");
						}, "Merge");
						//force refresh of navigation tool
						$('#navToolButton').attr("onclick", "toggleNavTool('Assigned IRB Admin Toolbar')");
					}else{
						//make sure executed for group size of more than 1
						row.appendChild(buildGeneralIRBAdminSelecter(irbAdmins));
						row.appendChild(generateStudyToolTabs(targetTool));
					}
				});
	        }
		});
	}else if(targetTool == "reviewComments"){
		if(validSection.length == 0)
			window.setTimeout(function(){swapToolGenerator(targetTool)}, 2000);
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildAdminComments());
			row.appendChild(buildReviewersComments());
			row.appendChild(generateReviewerToolTabs(targetTool));
		});
	}else if(targetTool == "reviewChecklists"){
		sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('SiteAssets/Reviewer Checklists')/Files"), null, function(checklists){
			sendREST("GET", siteUrl.concat("_api/web/GetFolderByServerRelativeUrl('Shared%20Documents/"+assignedID+"/Review%20Team')/Files"), null, function(returnedFiles){
				row.appendChild(buildChecklistTemplates(checklists.d.results));
				row.appendChild(buildUploadedChecklists(returnedFiles.d.results, "Review%20Team"));
				row.appendChild(generateReviewerToolTabs(targetTool));
			});
		});
	}else if(targetTool == "reviewerSubmit"){
		//sendREST("GET", restPath.concat("study/"+assignedID+"/comments/"+targetStage), null, function(comments){		
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildSubmitComments(["Re-Submit to IRB Administrator"]));
			row.appendChild(buildAppHistory());
			row.appendChild(generateReviewerToolTabs(targetTool));
		});
	}else if(targetTool == "localSite"){
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			row.appendChild(buildSubmitComments());
			row.appendChild(generateLocalSiteToolTabs(targetTool));
		});
	}else if(targetTool == "CIRBAdmin"){
		commentsRollup(targetStage, function(comments) {
			mapComments(comments);
			//Custom Assign Study ID field, AND assignment to cIRB reviewer?
			row.appendChild(generateCIRBToolTabs(targetTool));
		});
	}

	$('#insert-tool').append(row);
}

function commentsRollup(stage, callback) {
	sendREST("GET", restPath + "study/" + assignedID + "/comments/" + stage + "/rollup", null, callback);
}

// Divide comments by user.
function mapComments(comments) {
	var i, name;
	appReviewComments = new Hashtable();
	for (i = 0; i < comments.length; i++) {
	    name = comments[i].user.displayName;
		if (!appReviewComments.containsKey(name)) {
			appReviewComments.put(name, "");
			reviewersComments.push(name);
		}
		appReviewComments.put(name, appReviewComments.get(name) + comments[i].hyperText + "\t" + comments[i].createdAt + "\n\n");
	}
}

function filterChecklists(checklists, filter){
	var filteredChecklists = [];

	for(var i=0; i<checklists.length; i++){
		if((checklists[i].Name).indexOf(filter) > -1){
			filteredChecklists.push(checklists[i]);
		}
	}

	return filteredChecklists;
}

function buildAdminReviewers(){
	var container, tableDiv, table, tbody, trow, text, tempCollection;
	//reviewerCollection = new HashSet();
	var reviewerCollection = [];

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 selecter-div"); 

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Current Reviewers", ["Name", "Role", "Remove"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	/*table body*/
	tbody = document.createElement("tbody");

	// reviewerCollection = buildUsers(irbReviewers);
	// tempCollection = reviewerCollection.values();

	/*Adding the primary reviewer to the reviewers collection*/
	if(spAppData.PrimaryReviewersId != null){
		//grabbing current reviewer's names from their IDs
		tempCollection = ramsUsers.values();
		reviewerCollection = [];

		for(var j=0; j<tempCollection.length; j++){
			if(spAppData.PrimaryReviewersId.results == tempCollection[j].Id)
				reviewerCollection.push(tempCollection[j]);
		}	

		/*Building the Reviewers Table based on users who have been added
		to the reviewers collection*/
		for(var i=0; i<reviewerCollection.length; i++){
			trow = document.createElement("tr");
			trow.appendChild(textCellHelper("td", reviewerCollection[i].Title));
			trow.appendChild(textCellHelper("td", "Primary"));
			trow.appendChild(textCellHelper("td", "Primary Reviewers can only be replaced."))
			//trow.appendChild(buttonCellHelper("Remove", "removePrimaryReviewer('"+reviewerCollection[i].Id+"')"));
			tbody.appendChild(trow);
		}	
	}

	/*Adding assigned reviewers to the the reviewers collection*/
	if(spAppData.ReviewersId != null){
		//grabbing current reviewer's names from their IDs
		tempCollection = ramsUsers.values();
		reviewerCollection = [];
		// console.log("tempCollection: " + tempCollection);
		// console.log("spAppData.ReviewersId.length " + spAppData.ReviewersId.results.length);
		for(var i=0; i<spAppData.ReviewersId.results.length; i++){
			for(var j=0; j<tempCollection.length; j++){
				if(spAppData.ReviewersId.results[i] == tempCollection[j].Id)
					reviewerCollection.push(tempCollection[j]);
			}		
		}

		/*Building the Reviewers Table based on users who have been added
		to the reviewers collection*/
		for(var i=0; i<reviewerCollection.length; i++){
			trow = document.createElement("tr");
			trow.appendChild(textCellHelper("td", reviewerCollection[i].Title));
			trow.appendChild(textCellHelper("td", "Assigned"));
			trow.appendChild(buttonCellHelper("Remove", "removeAssignedReviewer('"+reviewerCollection[i].Id+"')"));
			tbody.appendChild(trow);
		}
	}	

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);

	return container;
};

function buttonCellHelper(buttonType, onclickFunc, id, disabled){
	var cell, button, text;

	cell = document.createElement("td");
	cell.setAttribute("align", "center");

	button = document.createElement("button");
	button.setAttribute("type", "button");
	button.setAttribute("class", "btn btn-default btn-xs");
	button.setAttribute("title", buttonType);
	button.setAttribute("onclick", onclickFunc);
	
	if(id){
		button.setAttribute("id", id);
	}
	if(disabled){
		button.setAttribute("disabled", true);
	}
	
	text = document.createTextNode(buttonType);

	button.appendChild(text);
	cell.appendChild(button);

	return cell;
};

function selectCellHelper(id, labelText, displayOptions, onChangeFunc, disabled){
	var cell, label, text, select, option;

	cell = document.createElement("td");
	cell.setAttribute("align", "center");

	label = document.createElement("label");
	label.setAttribute("class", "sr-only");
	label.setAttribute("for", id);

	text = document.createTextNode(labelText);
	label.appendChild(text);

	cell.appendChild(label);

	select = document.createElement("select");
	select.setAttribute("class", "form-control");
	select.setAttribute("id", id);

	if(onChangeFunc){
		select.setAttribute("onchange", onChangeFunc);
	}
	
	if(disabled){
		select.setAttribute("disabled", true);
	}

	for(var i=0; i<displayOptions.length; i++){
		option = document.createElement("option");
		option.setAttribute("value", displayOptions[i]);

		text = document.createTextNode(displayOptions[i]);
		option.appendChild(text);
		select.appendChild(option);
	}

	cell.appendChild(select);
	return cell;
};

function checkboxCellHelper(id, labelText, onclickFunc){
	var cell, checkbox, label, id, text;

	cell = document.createElement("td");
	// cell.setAttribute("align", "left");

	label = document.createElement("label");
	label.setAttribute("class", "sr-only");
	label.setAttribute("for", id);

	text = document.createTextNode(labelText);
	label.appendChild(text);

	cell.appendChild(label);

	checkbox = document.createElement("input");
	checkbox.setAttribute("id", id);
	checkbox.setAttribute("type", "checkbox");

	if(onclickFunc)
		checkbox.setAttribute("onclick", onclickFunc)

	cell.appendChild(checkbox);

	return cell;
}

function textCellHelper(type, displayText, id){
	var cell, text;

	cell = document.createElement(type);
	cell.setAttribute("align", "center");
	cell.setAttribute("tabindex", "0");
	
	if(displayText){
		text = document.createTextNode(displayText);
	}else{
		text = document.createTextNode("");
	}
	
	if(id){
		cell.setAttribute("id", id);
	}
	cell.appendChild(text);

	return cell;
};

//hoping to use this to re-write the code, but would have to add in
//tool-tip and required astrik as well.
function textFieldHelper(id, displayText, onChangeFunc){
	var form, formGroup, label, text, input;

	form = document.createElement("form");
	form.setAttribute("role", "form");

	formGroup = document.createElement("div");
	formGroup.setAttribute("class", "form-group");

	label = document.createElement("label");
	label.setAttribute("for", id);
	formGroup.appendChild(label);

	var text = document.createTextNode(displayText);
	formGroup.appendChild(text);

	input = document.createElement("input");
	input.setAttribute("name", id);
	input.setAttribute("class", "form-control normal");
	input.setAttribute("id", id);
	input.setAttribute("type", "text");
	if(onChangeFunc)
		input.setAttribute("onchange", onChangeFunc);
	formGroup.appendChild(input);

	form.appendChild(formGroup);

	return form;
};

//see description for textFieldHelper. Would also need to add id's
//for each radio button
function radioFieldHelper(id, displayText, radioQuestions){
	var form, formGroup, fieldSet, legend, text, input;

	form = document.createElement("form");

	formGroup = document.createElement("div");
	formGroup.setAttribute("class", "form-group");

	fieldSet = document.createElement("fieldset");

	legend = document.createElement("legend");
	text = document.createTextNode(displayText);
	legend.appendChild(text);
	fieldSet.appendChild(legend);

	for(var i=0; i<radioQuestions.length; i++){
		label = document.createElement("label");
		label.setAttribute("class", "radio");
		label.setAttribute("for", id + "_" + i);

		input = document.createElement("input");
		input.setAttribute("name", id);
		input.setAttribute("id", id + "_" + i);
		input.setAttribute("type", "radio");
		//if onclick and/or onchange
		label.appendChild(input);

		text = document.createTextNode(radioQuestions[i]);
		label.appendChild(text);

		fieldSet.appendChild(label);
	}

	formGroup.appendChild(fieldSet);
	form.appendChild(formGroup);

	return form;
}

function selectFieldHelper(id, displayText, selectOptions, onChangeFunc){
	var form, formGroup, label, text, select, option;

	form = document.createElement("form");
	form.setAttribute("role", "form");

	formGroup = document.createElement("div");
	formGroup.setAttribute("class", "form-group");

	label = document.createElement("label");
	label.setAttribute("for", id);

	text = document.createTextNode(displayText);
	label.appendChild(text);
	formGroup.appendChild(label);

	select = document.createElement("select");
	select.setAttribute("id", id);
	select.setAttribute("class", "form-control normal select");
	if(onChangeFunc){
		select.setAttribute("onchange", onChangeFunc);
	}

	for(var i=0; i<selectOptions.length; i++){
		option = document.createElement("option");
		option.setAttribute("value", selectOptions[i]);

		text = document.createTextNode(selectOptions[i]);
		option.appendChild(text);
		select.appendChild(option);
	}

	formGroup.appendChild(select);
	form.appendChild(formGroup);

	return form;
};

function linkCellHelper(type, displayText, teamFolder, linkName, target){
	var cell, text, link;

	cell = document.createElement(type);
	cell.setAttribute("align", "center");

	link = document.createElement("a");
	if(teamFolder && linkName){
		link.setAttribute("href", siteUrl.concat("Shared%20Documents/"+assignedID+"/"+teamFolder+"/"+linkName));
	}else{link.setAttribute("href", linkName);}
	
	if(target){
		link.target = target; //open link based on target selected
	}
	link.style.cursor = "pointer";

	text = document.createTextNode(displayText);
	link.appendChild(text);

	cell.appendChild(link);

	return cell;
};

function textareaCellHelper(type, id, labelText){
	var cell, text, label, input;

	cell = document.createElement(type);
	cell.setAttribute("align", "center");

	label = document.createElement("label");
	label.setAttribute("class", "sr-only");
	label.setAttribute("for", id);

	text = document.createTextNode(labelText);
	label.appendChild(text);

	cell.appendChild(label);

	input = document.createElement("input");
	input.setAttribute("class", "form-control");
	input.setAttribute("id", id);

	cell.appendChild(input);

	return cell;
}

function buildGeneralIRBAdminSelecter(irbAdmins){
	var container, tempCollection, adminSelecter;
	var availableAdmins = []; //array of administrator names
	adminCollection = new HashSet(); //global variable, similar to associative array
	var currentAdmin = null;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-3 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	adminCollection = buildUsers(irbAdmins); //parse the JSON data for administrators
	tempCollection = adminCollection.values();
	for(var i=0; i<tempCollection.length; i++){
		if(tempCollection[i].Id == spAppData.AssignedIRBAdministratorId){
			currentAdmin = tempCollection[i].Title;
		}else{
			availableAdmins.push(tempCollection[i].Title);
		}
	}	
	
	//sort array before adding values to dropdown
	availableAdmins.sort();

	if(currentAdmin != null){
		adminSelecter = buildSelecterHelper("addAdmin", "IRB Administrator: ", ["The Current Administrator is: " + currentAdmin].concat(availableAdmins), "12");
	}else{
		adminSelecter = buildSelecterHelper("addAdmin", "IRB Administrator: ", ["Please Select an Administrator"].concat(availableAdmins), "12");
	}

	row.appendChild(adminSelecter); //add dropdown to row
	container.appendChild(row);

	return container;
};

function buildPostApproveReview(){
	var container, row, date, label, text, table, cell, trow;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-1 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class" , "row selecter-text");

	table = document.createElement("table");
	table.setAttribute("class", "table");

	trow = document.createElement("tr");
	cell = document.createElement("td");

	label = document.createElement("label");
	label.setAttribute("class", "control-label");
	label.setAttribute("for", "continueReview");

	text = document.createTextNode("Set Renewal Date:");
	label.appendChild(text);

	cell.appendChild(label);
	trow.appendChild(cell);

	cell = document.createElement("td");

	date = document.createElement("input");
	date.setAttribute("type", "text");
	date.setAttribute("id", "continueReview");
	date.setAttribute("data-provide", "datepicker");
	date.setAttribute("date-date-format", "yyyy/mm/dd");
	date.setAttribute("class", "form-control datepicker");

	if(spAppData.RenewalDate != null){
		var renewalDate = spAppData.RenewalDate.split("T")[0];
		renewalDate = renewalDate.split("-");
		renewalDate = renewalDate[1] + "/" + renewalDate[2] + "/" + renewalDate[0];
		date.setAttribute("value", renewalDate);
	}
		
	cell.appendChild(date);
	trow.appendChild(cell);
	table.appendChild(trow);

	if(grabApplicationSiteType() == "Central"){
		trow = document.createElement("tr");
		cell = document.createElement("td");

		label = document.createElement("label");
		label.setAttribute("class", "control-label");
		label.setAttribute("for", "commentPeriod");

		text = document.createTextNode("Select Comment Period Start Date:");
		label.appendChild(text);

		cell.appendChild(label);
		trow.appendChild(cell);
		cell = document.createElement("td");

		date = document.createElement("input");
		date.setAttribute("type", "text");
		date.setAttribute("id", "commentPeriod");
		date.setAttribute("data-provide", "datepicker");
		date.setAttribute("date-date-format", "yyyy/mm/dd");
		date.setAttribute("class", "form-control");

		if(spAppData.OData__x0031_5DayCommentPeriod != null){
			var commentPeriod = spAppData.OData__x0031_5DayCommentPeriod.split("T")[0];
			commentPeriod = commentPeriod.split("-");
			commentPeriod = commentPeriod[1] + "/" + commentPeriod[2] + "/" + commentPeriod[0];
			date.setAttribute("value", commentPeriod); 
		}

		// date = document.createElement("button");
		// date.setAttribute("type", "button");
		// date.setAttribute("class", "btn btn-default");
		// date.setAttribute("id", "commentPeriod");

		// text = document.createTextNode("Start");
		// date.appendChild(text);

		cell.appendChild(date);
		trow.appendChild(cell);
		table.appendChild(trow);
	}

	row.appendChild(table);
	container.appendChild(row);
	return container;
}


// function dateHelper(){
// 	var container, date, label;

// 	container = document.createElement("div")

// 	date = document.createElement("input");
// 	date.setAttribute("type", "text");
// 	date.setAttribute("data-provide", "datepicker");

// 	cell.appendChild(date);

// 	return cell;
// }

/*builds all of the selecters in the Assignments tab*/
function buildAdminSelecters(irbAdmins, availableReviewers){

	var selectersDiv, adminSelecter, reviewerSelecter, reviewMethod, row, roleSelecter, tempCollection; 
	var availableAdmins = []; //array of administrator names
	
	adminCollection = new HashSet(); //global variable, similar to associative array
	var currentAdmin = null;

	selectersDiv = document.createElement("div");
	selectersDiv.setAttribute("class", "col-xs-4 col-md-offset-1 selecter-div");

	/*IRB Admin drop down*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	//collect admin names for dropdown
	adminCollection = buildUsers(irbAdmins);
	tempCollection = adminCollection.values();
	for(var i=0; i<tempCollection.length; i++){
		if(tempCollection[i].Id == spAppData.AssignedIRBAdministratorId){
			currentAdmin = tempCollection[i].Title;
		}else{
			availableAdmins.push(tempCollection[i].Title);
		}
	}

	//sort arrays before adding values to dropdown
	availableAdmins.sort();
	availableReviewers.sort();

	if(currentAdmin != null){
		adminSelecter = buildSelecterHelper("addAdmin", "Reassign IRB Administrator: ", ["The Current Administrator is: " + currentAdmin].concat(availableAdmins), "12");
	}else{
		adminSelecter = buildSelecterHelper("addAdmin", "Select IRB Administrator: ", ["Please Select an Administrator"].concat(availableAdmins), "12");
	}
	
	row.appendChild(adminSelecter);
	selectersDiv.appendChild(row);

	/*Add reviewer and assign a role*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	reviewerSelecter = buildSelecterHelper("addReviewer", "Add Reviewer: ", ["Please Select a Reviewer"].concat(availableReviewers), "6");
	row.appendChild(reviewerSelecter);

	roleSelecter = buildSelecterHelper("assignRole", "Role: ", ["Primary", "Assigned"], "6");
	row.appendChild(roleSelecter);
	selectersDiv.appendChild(row);

	/*compliant method of review drop down*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	if(spAppData.ApplicationType != null){
		var temp = spAppData.ApplicationType.split(' ');
		spAppData.Checkboxes = temp[1];
		spAppData.ApplicationType = temp[0];
		reviewMethod = buildSelecterHelper("assignReviewMethod", "Compliant Method of Review: ", ["The Current Compliant Method of Review is: "+spAppData.ApplicationType+"", "Exempt", "Expedited", "Full"], "12", "selectCheckBoxes('assignReviewMethod','reviewMethodCategory')");
	}else{
		reviewMethod = buildSelecterHelper("assignReviewMethod", "Compliant Method of Review: ", ["Please Select a Compliant Method of Review", "Exempt", "Expedited", "Full"], "12", "selectCheckBoxes('assignReviewMethod','reviewMethodCategory')");
	}

	row.appendChild(reviewMethod);
	selectersDiv.appendChild(row);
			
	/* Additional Category Information dropdown*/
	var row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");
	row.setAttribute("id", "reviewMethodCategory");
	row.style.fontSize = "10px";	
	row.style.lineHeight = "1.0";
	selectersDiv.appendChild(row);
	
	return selectersDiv;
};


function selectCheckBoxes(selectID, insertID){
	var selectOptions;
	var tempChoice;	
	var chkResponses = spAppData.Checkboxes;

	if(selectID == '0'){
		tempChoice = spAppData.ApplicationType;
	}else
		tempChoice = $('#'+selectID).val();

	if(tempChoice.indexOf("Expedited") != -1){
		selectOptions = ["Drugs/Devices without need for IND/IDE", "Minimal draw of blood samples", "Non-invasively collected biological specimens", "Non-invasively collected data from clinical practice", "Data/documents collected for non-research", "Voice/video/image for research", "Behavioral characteristics or survey/interview/program evaluation/QA"];
	}else if(tempChoice.indexOf("Exempt") != -1){
		selectOptions = ["Educational Settings", "Educational Tests", "Public Officials", "Existing Data", "Demonstration", "Food"];	
	}else
		selectOptions = [];
	
	$("#"+insertID).empty();
	selectOptions.forEach(function(o,i){
		var opt = checkboxCellHelper("chkOpt"+i, o);
		$("#"+insertID).append(opt);
		$("#"+insertID).append(textCellHelper("td", o));
		if((i+1)%2==0)
			$("#"+insertID).append(document.createElement('br'));
	});
	
	if(chkResponses != null && (chkResponses.length == selectOptions.length))
		for(var i=0; i<chkResponses.length; i++){
			if(chkResponses.charAt(i) == "*")
				$("#chkOpt"+i).prop('checked', true);
		}	
};



/*helps to build the selecters in the assignments tab*/
function buildSelecterHelper(id, displayText, displayOptions, length, onChangeFunc, disabled){
	var selecterDiv, selecterRow, selecterContainer, label, selecter, option, text;

	selecterDiv = document.createElement("div");
	selecterDiv.setAttribute("class", "col-xs-"+length);

	label = document.createElement("label");
	label.setAttribute("for", id);
	label.setAttribute("class", "control-label");

	text = document.createTextNode(displayText);
	label.appendChild(text);
	selecterDiv.appendChild(label);

	selecter = document.createElement("select");
	selecter.setAttribute("class", "form-control");
	selecter.setAttribute("id", id);

	if(onChangeFunc){
		selecter.setAttribute("onchange", onChangeFunc);
	}
	
	if(disabled){ //if disabled argument is set to true
		selecter.setAttribute("disabled", disabled); //disable dropdown
	}

	for(var i=0; i<displayOptions.length; i++){
		option = document.createElement("option");
		option.setAttribute("value", displayOptions[i]);

		text = document.createTextNode(displayOptions[i]);
		option.appendChild(text);
		selecter.appendChild(option);
	}	
	
	selecterDiv.appendChild(selecter);
	return selecterDiv;
};

function generateViewgenComments(id, spacing, displayText, publishedComments){
	var container, label, textarea, text, row;

	container = document.createElement("div");
	container.setAttribute("class", spacing);

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	label = document.createElement("label");
	label.setAttribute("for", id);

	text = document.createTextNode(displayText);
	label.appendChild(text);
	row.appendChild(label);

	textarea = document.createElement("textarea");
	textarea.setAttribute("id", id);
	textarea.setAttribute("class", "form-control");
	textarea.setAttribute("rows", "10");

	if(publishedComments != null){
		for(var i=0; i<publishedComments.length; i++){
			text = document.createTextNode(publishedComments[i].hyperText);
			textarea.appendChild(text);
		}	
	}

	row.appendChild(textarea);
	container.appendChild(row);

	return container;
};

/*toolbar structure includes the navbutton and 
the general floating nav at the bottom of the page.*/
function generateToolStructure(toolbarText){
	var navButton, navTool, containerDiv, collapseDiv

	navButton = generateNavButton(toolbarText);
	$('body').append(navButton);

	navTool = document.createElement("nav");
	navTool.setAttribute("class", "navbar navbar-fixed-bottom navbar-test collapse");
	navTool.setAttribute("id", "responsive-nav");

	containerDiv = document.createElement("div");
	containerDiv.setAttribute("class", "container-fluid");

	collapseDiv = document.createElement("div");
	collapseDiv.setAttribute("class", "collapse navbar-collapse");
	collapseDiv.setAttribute("id", "insert-tool");

	containerDiv.appendChild(collapseDiv);
	navTool.appendChild(containerDiv);
	
	$('body').append(navTool);
};

function generateNavButton(toolbarText){
	var nav, button, icon, text;

	nav = document.createElement("nav");
	nav.setAttribute("class", "navbar navbar-fixed-top");
	nav.setAttribute("style", "width: 160px");

	button = document.createElement("button");
	button.setAttribute("class", "btn btn-default");
	button.setAttribute("type", "button");
	button.setAttribute("data-toggle", "collapse");
	button.setAttribute("data-target", "#responsive-nav");
	button.setAttribute("aria-expanded", "false");
	button.setAttribute("aria-controls", "responsive-nav");
	button.setAttribute("id", "navToolButton");
	button.setAttribute("onclick", "toggleNavTool('"+toolbarText+"')");
	button.setAttribute("value", "expanded");

	text = document.createTextNode("Expand " + toolbarText);
	
	button.appendChild(text);

	icon = document.createElement("span");
	icon.setAttribute("class", "glyphicon glyphicon-chevron-up");
	icon.setAttribute("aria-hidden", "true");
	button.appendChild(icon);

	
	if($('#navToolButton').length == 0)
		nav.appendChild(button);

	return nav;
};

function toggleNavTool(toolbarText){
	var icon;
	var navToolButton = $('#navToolButton');
	var navBarClass = $('.navbar-test').attr("class");

	if(navBarClass.indexOf("collapse") > -1){
		//toolbar currently expanded/up
		navToolButton.val("collapsed");

		//removes children and replaces text
		navToolButton.text("Collapse " + toolbarText);

		//adding back the icon
		icon = document.createElement("span");
		icon.setAttribute("class", "glyphicon glyphicon-chevron-down");
		icon.setAttribute("aria-hidden", "true");
		navToolButton.append(icon);

	}else{
		//toolbar currently collapsed/down
		navToolButton.val("expanded");

		//removes children and replaces text
		navToolButton.text("Expand " + toolbarText);

		//adding back the icon
		icon = document.createElement("span");
		icon.setAttribute("class", "glyphicon glyphicon-chevron-up");
		icon.setAttribute("aria-hidden", "true");
		navToolButton.append(icon);
	}
};

function generateToolTabs(targetTool){
	var save, cancel, container, column, row, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-3");

	row = document.createElement("div");
	row.setAttribute("class", "row");

	column = document.createElement("div");
	column.setAttribute("class", "col-xs-6 btn-group-vertical");
	column.setAttribute("role", "group");

	/*Assignments button*/
	column.appendChild(tabLabelMaker("assignApp", "Assignments"));
	column.appendChild(tabButtonMaker("assignApp", "1.Assignments", "user"));

	/*Review button*/
	column.appendChild(tabLabelMaker("appReview", "Review"));
	column.appendChild(tabButtonMaker("appReview", "2.Review", "pencil"));

	/*Checklists button*/
	column.appendChild(tabLabelMaker("appChecklists", "Checklists"));
	column.appendChild(tabButtonMaker("appChecklists", "3.Checklists", "list-alt"));

	/*Approve button*/
	column.appendChild(tabLabelMaker("submitApp", "Submit Application"));
	column.appendChild(tabButtonMaker("submitApp", "4.Update Status", "send"));	

	/*Events button*/
	if((spAppData.ApplicationStatus.indexOf("Approved") > -1) && (currentFormType == "Parent")){
		column.appendChild(tabLabelMaker("appEvent", "Events"));
		column.appendChild(tabButtonMaker("appEvent", "Events", "bullhorn"));
	}

	row.appendChild(column);
	column = document.createElement("div");
	column.setAttribute("class", "col-xs-6 btn-group-vertical");
	column.setAttribute("role", "group");	

	/*Cancel Button*/
	column.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	column.appendChild(cancel);

	/*Print button*/
	column.appendChild(tabLabelMaker("piPrint", "Print Comments"));
	print = tabButtonMaker("piPrint", "Print", "print");
	print.removeAttribute("onclick");
	print.setAttribute("onclick", "printComments()");
	column.appendChild(print);

	/*Save button*/
	column.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	column.appendChild(save);

	row.appendChild(column);
	container.appendChild(row);

	return container;
};

function generateStudyToolTabs(targetTool){
	var container, save, cancel, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-2 btn-group-vertical");
	container.setAttribute("role", "group");

	/*Cancel Button*/
	container.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	container.appendChild(cancel);

	/*Print button*/
	container.appendChild(tabLabelMaker("piPrint", "Print Comments"));
	print = tabButtonMaker("piPrint", "Print", "print");
	print.removeAttribute("onclick");
	print.setAttribute("onclick", "printComments()");
	container.appendChild(print);

	/*Save button*/
	container.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	container.appendChild(save);

	return container;
};

function generateReviewerToolTabs(targetTool){
	var contianer, save, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-2 btn-group-vertical");
	container.setAttribute("role", "group");

	/*Review/comments*/
	container.appendChild(tabLabelMaker("reviewComments", "Review"));
	container.appendChild(tabButtonMaker("reviewComments", "1.Review", "pencil"));

	/*Checklists*/
	container.appendChild(tabLabelMaker("reviewChecklists", "Checklists"));
	container.appendChild(tabButtonMaker("reviewChecklists", "2.Checklists", "list-alt"));	

	/*Submit (back to IRB Admin)*/
	container.appendChild(tabLabelMaker("reviewerSubmit", "Submit Application"));
	container.appendChild(tabButtonMaker("reviewerSubmit", "3.Update Status", "send"));

	/*Cancel Button*/
	container.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	container.appendChild(cancel);

	/*Print button*/
	container.appendChild(tabLabelMaker("piPrint", "Print Comments"));
	print = tabButtonMaker("piPrint", "Print", "print");
	print.removeAttribute("onclick");
	print.setAttribute("onclick", "printComments()");
	container.appendChild(print);

	/*Save button*/
	container.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	container.appendChild(save);


	return container;

};

function generateLocalSiteToolTabs(targetTool){
	var contianer, save, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-2 btn-group-vertical");
	container.setAttribute("role", "group");

	/*Review/comments*/
	container.appendChild(tabLabelMaker("reviewComments", "Review"));
	container.appendChild(tabButtonMaker("reviewComments", "1.Review", "pencil"));	

	/*Submit (back to IRB Admin?*/
	container.appendChild(tabLabelMaker("reviewerSubmit", "Submit Application"));
	container.appendChild(tabButtonMaker("reviewerSubmit", "2.Update Status", "send"));

	/*Cancel Button*/
	container.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	container.appendChild(cancel);

	/*Print button*/
	container.appendChild(tabLabelMaker("piPrint", "Print Comments"));
	print = tabButtonMaker("piPrint", "Print", "print");
	print.removeAttribute("onclick");
	print.setAttribute("onclick", "printComments()");
	container.appendChild(print);

	/*Save button*/
	container.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	container.appendChild(save);


	return container;
}

function generateCIRBToolTabs(targetTool){
	var container, save, cancel, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-2 btn-group-vertical");
	container.setAttribute("role", "group");

	/*Cancel Button*/
	container.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	container.appendChild(cancel);

	/*Save button*/
	container.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	container.appendChild(save);

	/*Submit button*/
	container.appendChild(tabLabelMaker("piSubmitApp", "Submit Application"));
	container.appendChild(tabButtonMaker("piSubmitApp", "Update Status", "send"));

	return container;
}

function generatePIToolTabs(targetTool){
	var save, print;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-2 btn-group-vertical");
	container.setAttribute("role", "group");

	/*comments button*/
	container.appendChild(tabLabelMaker("piComments", "Review"));
	container.appendChild(tabButtonMaker("piComments", "1.Review", "pencil"));

	/*adverse events*///moving to approved toolbar
	//container.appendChild(tabLabelMaker("adverseEvent", "Adverse Event"));
	//container.appendChild(tabButtonMaker("postApproveEvents", "Adverse Event", "bullhorn"));

	/*checklists*/
	container.appendChild(tabLabelMaker("piChecklists", "Checklists"));
	container.appendChild(tabButtonMaker("piChecklists", "2.Checklists", "list-alt"));
	
	/*Approve button*/
	container.appendChild(tabLabelMaker("piSubmitApp", "Submit Application"));
	container.appendChild(tabButtonMaker("piSubmitApp", "3.Update Status", "send"));

	/*Cancel Button*/
	container.appendChild(tabLabelMaker("cancelToolbar", "Cancel Changes"));
	cancel = tabButtonMaker("cancelToolbar", "Exit", "trash");
	cancel.removeAttribute("onclick");
	cancel.setAttribute("onclick", "Function(window.history.back())");
	container.appendChild(cancel);

	/*Print button*/
	container.appendChild(tabLabelMaker("piPrint", "Print Comments"));
	print = tabButtonMaker("piPrint", "Print", "print");
	print.removeAttribute("onclick");
	print.setAttribute("onclick", "printComments()");
	container.appendChild(print);

	/*Save button*/
	container.appendChild(tabLabelMaker("saveAdminTool", "Save Admin Comments"));
	save = tabButtonMaker("saveAdminTool", "Save", "floppy-disk");
	save.removeAttribute("onclick");
	save.setAttribute("onclick", "saveProgress('"+targetTool+"')");
	container.appendChild(save);

	return container;
}

function printComments(){
	var winPrint = window.open('about:blank', '_blank');
	var text = "<title>Print Report</title><br /><br /><span style='white-space: pre-line'>";
	$("#reviewerComments").find('option').each( function(){
		if($(this).val().indexOf(",") != -1){
			text+= "<br />-------"+$(this).val()+"----------<br />";
			text+= appReviewComments.get($(this).val());
		}
	});
	text += "</span>";
	winPrint.document.write(text);
	winPrint.document.close();
	winPrint.focus();
	winPrint.print();	
}

function tabLabelMaker(id, title){
	var label, text;

	/*only the screen reader will see this*/
	label = document.createElement("label");
	label.setAttribute("class", "sr-only");
	label.setAttribute("for", id);

	text = document.createTextNode(title);
	label.appendChild(text);

	return label;
}

function tabButtonMaker(id, displayText, iconType){
	var button, icon, text;

	button = document.createElement("button");
	button.setAttribute("type", "button");
	button.setAttribute("class", "btn btn-default");
	button.setAttribute("id", id);

	text = document.createTextNode(displayText);
	button.appendChild(text);

	icon = document.createElement("span");
	icon.setAttribute("class", "glyphicon glyphicon-"+iconType);
	icon.setAttribute("aria-hidden", "true");
	button.appendChild(icon);
	button.setAttribute("onclick", "swapToolGenerator('"+id+"')");

	return button;
}

function buildAdminComments(){
	var container, row, commentTypeSelecter, sectionSelecter, questionSelecter, commentArea, text;
	var commentOptions = [];
	var question = [];
	var section = [];
	var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-1 selecter-div");
	
	/* User must write general or specific comment*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");
		
	commentOptions.push("Select Comment Type: ", "General Comment", "Specific Comment");
	commentTypeSelecter = buildSelecterHelper("addCommentType", "Select General or Specific Comment", commentOptions, "12", "enableDropdowns(['addCommentSection', 'addCommentQuestion'])");
	row.appendChild(commentTypeSelecter);
	container.appendChild(row); //add 1st dropdown to toolbar
	
	/*Add comment*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	//Default text added to section dropdown
	section.push("Select a Section: ");
	
	/*Specify Section to add comment to*/
	for(var i=0; i<validSection.length; i++){
		section.push("Section " + sectionTitle.charAt(validSection[i]));
	}

	sectionSelecter = buildSelecterHelper("addCommentSection", "Add Comment, Section: ", section, "6", "switchSection('addCommentSection', 'addCommentQuestion')", true);
	row.appendChild(sectionSelecter);

	//Default text added to question dropdown
	question.push("Select a Question: ");
	
	/*Specify Question to add comment to*/
	for(var i=0; i<$("form").length; i++){
		question.push("Question " + (i+1));
	}

	questionSelecter = buildSelecterHelper("addCommentQuestion", "Question: ", question, "6", null, true);
	row.appendChild(questionSelecter);

	container.appendChild(row);

	/*Area to type comments into*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	commentArea = buildTextareaHelper("addComment", null, "12", "Add Comment:", "9");
	row.appendChild(commentArea);
	container.appendChild(row);

	return container;
};

function buildReviewersComments(){
	var container, row, reviewerSelecter, reviewerComments;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 selecter-div");

	/*Pick a reviewer's comments*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*pass buildselecter an onclick function
	this function will be insert review comments
	pass the person
	determine if person is reviewer or admin
	insert comments accordingly*/

	/*build list of people to send, if there are no people, remove 
	onclick and display "no reviews"*/

	//currently assuming everyone is a reviewer
	reviewerSelecter = buildSelecterHelper("reviewerComments", "View Comments: ", ["Please Select a User:"].concat(appReviewComments.keys(), "View All"), "12", "selectToText('reviewerComments', 'viewComments')");
	reviewerSelecter.setAttribute("style", "padding-bottom: 4px;");
	row.appendChild(reviewerSelecter);

	container.appendChild(row);

	/*View a reviewer's comments*/
	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	reviewerComments = buildTextareaHelper("viewComments", "true", "12", "View Comments:", "13");
	row.appendChild(reviewerComments);

	container.appendChild(row);

	return container;
};

/*Correlates a user in a drop down box to their comments*/
function selectToText(selectID, insertID){
	var person = $("#"+selectID).find(':selected').val(); 
	var allComments = "";

	/*assuming that if a person in the drop-down, then they'll
	have a comma in their name*/
	if(person.indexOf(":") != -1){
		person = currentUser.Title;
	}

	if(person.indexOf(",") == -1){
		$("#"+selectID).find('option').each( function(){
			if($(this).val().indexOf(",") != -1){
				allComments += "\n-------"+$(this).val()+"----------\n";
				allComments += appReviewComments.get($(this).val());
			}
		});
		$("#"+insertID).val(allComments);
	}else if((appReviewComments) && (appReviewComments.containsKey(person))){
		$("#"+insertID).val(appReviewComments.get(person));
	}else{
		$("#"+insertID).val("No comments available.");
	}
};

function enableDropdowns(dropdownList){ //enable (or disable) section and question dropdown for specific comment
	var commentType = $("#"+'addCommentType').find(':selected').val();
	if(commentType == "Specific Comment"){ //enable dropdowns again
		for(var i=0; i<dropdownList.length; i++){
			$("#"+(dropdownList[i])).removeAttr("disabled"); 
		}
	}else{ //make sure other dropdowns disabled
		for(var i=0; i<dropdownList.length; i++){ 
			if(dropdownList[i] == "addCommentSection"){ //set back to default value before disabling
				$("#addCommentSection").val("Select a Section: "); 
				$("#addCommentQuestion").val("Select a Question: "); //gets set to blank value for some reason
			}if(($("#"+(dropdownList[i])).attr("disabled") !== typeof undefined) && ($("#"+(dropdownList[i])).attr("disabled") !== false)){ //check if dropdown isn't disabled
				$("#"+(dropdownList[i])).attr("disabled", true);
			}
		}
	}
};


function switchSection(sectionID, questionID){ //moves page to specific section & generates the options in the question dropdown
	var targetSection = $("#"+sectionID).find(':selected').val();
	var option, text;

if(targetSection != "Select a Section: "){
		targetSection = targetSection.split(" ")[1]; //get letter of section

		var letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		targetSection = letters.indexOf(targetSection); //find index of letter in alphabet

		continueSectionBuilder(targetSection);

		$("#"+questionID).children().remove(); //remove old options
		for(var i=0; i<($("form").length); i++){ //add new options
			option = document.createElement("option");
			option.setAttribute("value", "Question " + (i+1));

			text = document.createTextNode("Question " + (i+1));
			option.appendChild(text);

			$('#'+questionID).append(option);
		}
	}
};

function buildTextareaHelper(id, disabler, length, title, rows){
	var container, label, textarea, text;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-"+length);

	label = document.createElement("label");
	label.setAttribute("class", "sr-only");
	label.setAttribute("for", id);

	text = document.createTextNode(title);
	label.appendChild(text);
	container.appendChild(label);

	textarea = document.createElement("textarea");
	textarea.setAttribute("id", id);
	textarea.setAttribute("class", "form-control");
	
	if(rows){
		textarea.setAttribute("rows", rows); 
	}else{ //default number of rows for textbox is 7
		textarea.setAttribute("rows", "7");
	}
	container.appendChild(textarea);

	return container;
};

function buildChecklistTemplates(checklists){
	var container, row, table, tbody, trow, tableDiv, text;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-1 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Available Checklist Templates", ["Checklist Type", "Download"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");
	tableDiv.setAttribute("style", "height: 83px");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	tbody = document.createElement("tbody");
	for(var i=0; i<checklists.length; i++){
		trow = document.createElement("tr");
		trow.appendChild(textCellHelper("td", checklists[i].Name));
		trow.appendChild(buttonCellHelper("Download", "downloadChecklist('"+checklists[i].ServerRelativeUrl+"')"));
		tbody.appendChild(trow);
	}

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);

	container.appendChild(fileSelectorBuilder("uploadChecklist", "Upload Checklist:"));

	return container;
};

function fileSelectorBuilder(id, displayText){
	var container, label, input, labelDiv, inputDiv, text;

	container = document.createElement("div");
	container.setAttribute("class", "row selecter-text");

	labelDiv = document.createElement("div");
	labelDiv.setAttribute("class", "col-xs-4");

	label = document.createElement("label");
	label.setAttribute("for", id);

	text = document.createTextNode(displayText);
	label.appendChild(text);
	
	labelDiv.appendChild(label);
	container.appendChild(labelDiv);

	inputDiv = document.createElement("div");
	inputDiv.setAttribute("class", "col-xs-8");

	input = document.createElement("input");
	input.setAttribute("type", "file");
	input.setAttribute("id", id);

	inputDiv.appendChild(input);
	container.appendChild(inputDiv);

	return container;
};

function buildUploadedChecklists(attachments, teamFolder){
	var container, row, tableDiv, table, tbody, trow, text, fileName; 

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Current Uploaded Checklists", ["Checklist Type", "Date"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	tbody = document.createElement("tbody");


	for(var i=0; i<attachments.length; i++){
		trow = document.createElement("tr");

		if(teamFolder == "Study%20Team"){
			fileName = (attachments[i].Name).replace("-CHECKLIST-", "");
		}else{
			fileName = attachments[i].Name;
		}

		trow.appendChild(linkCellHelper("td", fileName, teamFolder, attachments[i].Name));
		text = attachments[i].TimeCreated.split("T")[1].replace("Z", "") + " on " + attachments[i].TimeCreated.split("T")[0];
		trow.appendChild(textCellHelper("td", text));
		tbody.appendChild(trow);
	}

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);
	
	return container;
};

/*Builds the table structure as well as the thead*/
function tableHeaderHelper(captionText, headers){
	var table, thead, trow, text, caption;

	//if there aren't enough elements for the table to scroll, then you don't need to 
	//include "tool-table" in the table's class
	table = document.createElement("table");
	table.setAttribute("class", "table table-striped selecter-text");

	if(captionText){
		caption = document.createElement("caption");
		text = document.createTextNode(captionText);
		caption.appendChild(text);
		table.appendChild(caption);
	}

	thead = document.createElement("thead");
	trow = document.createElement("tr");

	for(var i=0; i<headers.length; i++){
		trow.appendChild(textCellHelper("th", headers[i]));
	}
	
	thead.appendChild(trow);
	table.appendChild(thead);

	return table;
};

function grabComments(comments, user){
	userComments = [];

	for(var i=0; i<comments.length; i++){
		if(user == comments[i].user.SPUser)
			userComments.push(comments[i] + "\n");
	}

	return publishedComments;
}

function saveProgress(targetTool){
	// var saveButton = $('#saveAdminTool');

	// saveButton.fadeOut(400, function(){
	// 	saveButton.attr("class", "btn btn-default label-success");
	// 	saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
	// }).fadeIn(600);
	
	//console.log("the target tool is: " + targetTool);

	if(targetTool == "appReview"){
		sendAppReview(targetTool);
	}else if(targetTool == "assignApp"){
		sendAssignApp(targetTool);
	}else if(targetTool == "submitApp"){
		var approvalType = $('#selectApproval').val();
		if(approvalType == "Re-Submit to Study Team"){
			sendSubmitApp("Awaiting Revisions", "Revision");
		}else if(approvalType == "Approve Application"){
			sendSubmitApp("Approved", "Approved");
			notifyLocalSitesOnParentStatus(assignedID, "Approved") // this will update the children studies with status of parent Approved status
		}else if(approvalType == "Approve with Minor Modifications"){
			sendSubmitApp("Approved with Minor Modifications", "Minor Mods");
		}else if(approvalType == "Approve with Major Modifications"){
			sendSubmitApp("Approved with Major Modifications", "Major Mods");
		}else if(approvalType == "Suspend"){
			sendSubmitApp("Suspended", "Suspended");
		}else if(approvalType == "Rejected"){
			sendSubmitApp("Disapproved", "Rejected");
		}
	}else if(targetTool == "studyComments"){
		sendAppReview(targetTool);
	}else if(targetTool == "piSubmitApp"){
		sendSubmitApp("Under Review", "Review");
	}else if(targetTool == "assignIRBAdmin"){
		sendAssignApp(targetTool);
	}else if(targetTool == "reviewerSubmit"){
		publishComments(targetTool);
		window.location.href("/sitepages/irb%20applications.aspx"); //added line
	}else if(targetTool == "reviewComments"){
		sendAppReview(targetTool);
	}else if(targetTool == "appEvent"){
		sendRenewalDate(targetTool);
	}else if((targetTool == "appChecklists") || (targetTool == "reviewChecklists")){
		sendReviewChecklist(targetTool, "Review%20Team");
	}else if(targetTool == "piChecklists"){
		sendReviewChecklist(targetTool, "Study%20Team");
	}else if(targetTool == "piComments"){
		sendAppReview(targetTool);
	}

};

function buildSubmitComments(submissionTypes){
	var container, row, selecter, textarea;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-1 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	selecter = buildSelecterHelper("selectApproval", "Submission Type: ", ["Please Select a Submission"].concat(submissionTypes), "12", "selectToText('selectApproval', 'submissionComment')");
	row.appendChild(selecter);

	// selecter = buildSelecterHelper("renewalDate", "Renewal Date: ", ["Date 1", "Date 2", "Date 3"], "6", null);
	// row.appendChild(selecter);

	container.appendChild(row);

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	textarea = buildTextareaHelper("submissionComment", null, "12", "Submission Comments: ");
	row.appendChild(textarea);

	container.appendChild(row);

	return container;
};

function buildAppHistory(){
	var container, row, table, tbody, trow, tableDiv, text;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Application History", ["Event Type", "Date", "Actor"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	//console.log("we have " + currentStudyStatus.length + " events");

	tbody = document.createElement("tbody");
	for(var i=0; i<currentStudyStatus.length; i++){
		trow = document.createElement("tr");
		trow.appendChild(textCellHelper("td", currentStudyStatus[i].studyState.name));
		trow.appendChild(textCellHelper("td", currentStudyStatus[i].createdAt.split("T")[0]));
		trow.appendChild(textCellHelper("td", currentStudyStatus[i].createdBy.displayName));
		tbody.appendChild(trow);
	}

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);

	return container;
};

function buildAddEvent(){
	var container, row, table, tbody, trow, tableDiv, text;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 col-md-offset-2 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Create New Event", ["Event Type", "Create"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	tbody = document.createElement("tbody");

	/*Local Event*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Local Site"));
	trow.appendChild(buttonCellHelper("Create Event", "createLocalEvent()"));
	tbody.appendChild(trow);

	/*Adverse Event*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Adverse/Reportable"));
	trow.appendChild(buttonCellHelper("Create Event", "createAdverseEvent()"));
	tbody.appendChild(trow);

	
	/*Continuing Review*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Continuing Review"));
	trow.appendChild(buttonCellHelper("Create Event", "createContReview()"));
	tbody.appendChild(trow);

	/*Closeout*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Closeout"));
	trow.appendChild(buttonCellHelper("Create Event", "createCloseoutReview()"));
	tbody.appendChild(trow);

	/*Admin Update*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Administrative Update"));
	trow.appendChild(buttonCellHelper("Create Event", "createAdminUpdate()"));
	tbody.appendChild(trow);

	/*Amendment*/
	trow = document.createElement("tr");
	trow.appendChild(textCellHelper("td", "Amendment"));
	trow.appendChild(buttonCellHelper("Create Event", "createAmendment()"));
	tbody.appendChild(trow);	

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);

	return container;
};

function buildEventHistory(){
	var container, row, table, tbody, trow, tableDiv, text;

	container = document.createElement("div");
	container.setAttribute("class", "col-xs-4 selecter-div");

	row = document.createElement("div");
	row.setAttribute("class", "row selecter-text");

	/*Header Table*/
	table = tableHeaderHelper("Event History", ["Event Type", "Date", "View"]);
	row.appendChild(table);

	/*Scrollable Body Table*/
	tableDiv = document.createElement("div");
	tableDiv.setAttribute("class", "div-table-content");

	table = document.createElement("table");
	table.setAttribute("class", "table table-striped table-hover");

	tbody = document.createElement("tbody");
	
	var tempStudies = childrenStudies.values();
	for(var i=0; i<tempStudies.length; i++){
		trow = document.createElement("tr");
		trow.appendChild(textCellHelper("td", tempStudies[i].ApplicationType));
		trow.appendChild(textCellHelper("td", tempStudies[i].Created));
		trow.appendChild(buttonCellHelper("View", "Function(window.location.href('irb-applications-general.html?"+tempStudies[i].Study_ID+"'))"));
		tbody.appendChild(trow);
	}

	table.appendChild(tbody);
	tableDiv.appendChild(table);
	row.appendChild(tableDiv);
	container.appendChild(row);

	return container;
};

function sendAppReview(targetTool){
	if(targetState == 2){
		setup(currentUser.Id);
	}
		
	var committeeName=getCommitteeDisplay();
	var saveButton = $('#saveAdminTool');
	var commentType = $('#addCommentType').find(':selected').val();
	var section = $('#addCommentSection').find(':selected').val();
	var question = $('#addCommentQuestion').find(':selected').val();
	
	var comment = $('#addComment').val();
	var textToDisplay;
	data = [];

	//customize how comment displayed based on type of comment
	if (commentType == "General Comment"){ //comment type is general
		textToDisplay = "(" + committeeName + commentType + ")\n" + comment + "\n";
	}else{ //comment type is specific - pertaining to a section and question number
		textToDisplay = "(" + committeeName + commentType + " -- " + section + " -- " + question + ")\n" + comment + "\n";
	}
	
	var package = {
		//"formsID": section,
		"formsID": "250",
		"hyperText": textToDisplay,
		"published": "false",
		"questionsID": "8518",
		"redFlagged": "false"
	};	

	data.push(package);

	sendREST("POST", restPath.concat("study/"+assignedID+"/comments/"+targetStage), data, function(){
		swapToolGenerator(targetTool);
		//saveButton.fadeOut(400, function(){
		// 	saveButton.attr("class", "btn btn-default label-success");
		// 	saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
		// }).fadeIn(600);
	});

};

function sendRenewalDate(targetTool){
	var saveButton = $('#saveAdminTool');
	var renewalDate = $('#continueReview').val();
	var commentDate = $('#commentPeriod').val();

	if(((renewalDate != "") && (renewalDate != null)) || ((commentDate != "") && (commentDate != null))){
		
		if((renewalDate != "") && (renewalDate != null)){
			renewalDate = renewalDate.split("/");
			renewalDate = renewalDate[2] + "-" + renewalDate[0] + "-" + renewalDate[1] + "T05:00:00Z";
		}

		if((commentDate != "") && (commentDate != null)){
			commentDate = commentDate.split("/");
			commentDate = commentDate[2] + "-" + commentDate[0] + "-" + commentDate[1] + "T05:00:00Z";
		}

		if((renewalDate != spAppData.RenewalDate) && (commentDate != spAppData.OData__x0031_5DayCommentPeriod)){
			data = {
				"__metadata": spAppData.__metadata,
				"RenewalDate": renewalDate,
				"OData__x0031_5DayCommentPeriod": commentDate
			}

			spAppData.RenewalDate = renewalDate;
			spAppData.OData__x0031_5DayCommentPeriod = commentDate;
		}else if(renewalDate != spAppData.RenewalDate){
			data = {
				"__metadata": spAppData.__metadata,
				"RenewalDate": renewalDate				
			}

			spAppData.RenewalDate = renewalDate;
		}else if(commentDate != spAppData.OData__x0031_5DayCommentPeriod){
			data = {
				"__metadata": spAppData.__metadata,
				"OData__x0031_5DayCommentPeriod": commentDate				
			}

			spAppData.OData__x0031_5DayCommentPeriod = commentDate;
		}				

		sendREST("POST", spAppData.__metadata.uri, data, function(){
			sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){	
				//swapToolGenerator(targetTool);
				saveButton.fadeOut(400, function(){
					saveButton.attr("class", "btn btn-default label-success");
					saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
				}).fadeIn(600);				
			}, "Merge");
		}, "Merge");
	}

	// else if((renewalDate != "") && (renewalDate != null)){
	// 	renewalDate = renewalDate.split("/");
	// 	renewalDate = renewalDate[2] + "-" + renewalDate[0] + "-" + renewalDate[1] + "T05:00:00Z";

	// 	if(renewalDate != spAppData.RenewalDate){
	// 		renewalData = {
	// 			"__metadata": spAppData.__metadata,
	// 			"RenewalDate": renewalDate
	// 		}

	//  		spAppData.RenewalDate = renewalDate;

	// 		sendREST("POST", spAppData.__metadata.uri, renewalData, function(){
	// 			sendREST("POST", spsubsiteAppData.__metadata.uri, renewalData, function(){	
	// 				//swapToolGenerator(targetTool);
	// 			saveButton.fadeOut(400, function(){
	// 				saveButton.attr("class", "btn btn-default label-success");
	// 				saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
	// 			}).fadeIn(600);				
	// 			}, "Merge");
	// 		}, "Merge");
	// 	}
	// }else if((commentDate != "") && (commentDate != null)){
	// 	//grab local site liaison
	// 	commentDate = commentDate.split("/");
	// 	commentDate = commentDate[2] + "-" + commentDate[0] + "-" + commentDate[1] + "T05:00:00Z";

	// 	if(commentDate != spAppData.OData__x0031_5DayCommentPeriod){
	// 		commentData = {
	// 			"__metadata": spAppData.__metadata,
	// 			"OData__x0031_5DayCommentPeriod": commentDate
	// 		}

	// 		spAppData.OData__x0031_5DayCommentPeriod = commentDate;

	// 		sendREST("POST", spAppData.__metadata.uri, commentData, function(){
	// 			sendREST("POST", spsubsiteAppData.__metadata.uri, commentData, function(){	
	// 				//swapToolGenerator(targetTool);
	// 				saveButton.fadeOut(400, function(){
	// 					saveButton.attr("class", "btn btn-default label-success");
	// 					saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
	// 				}).fadeIn(600);				
	// 			}, "Merge");
	// 		}, "Merge");		
	// 	}
	// }
};

function sendAssignApp(targetTool){
	var saveButton = $('#saveAdminTool');
	var admin = $('#addAdmin').find(':selected').val(); //find value from dropdown --"Please..." or "The Current"
	var reviewer = $('#addReviewer').find(':selected').val();
	var reviewerRole = $('#assignRole').val();
	var CMOD = $('#assignReviewMethod').find(':selected').val();
	var chkBoxesInt = "";
	var tempCollection, data, currentReviewers;

	//need to grab these people from the admincollection and then add them to the SP lists.
	if((admin != "Please Select an Administrator") && (admin.indexOf("The Current") == -1)){ //display name selected
		tempCollection = adminCollection.values();
		if(admin == currentUser.Title){
			targetTool = "assignApp";
		}
		for(var i=0; i<tempCollection.length; i++){
			if(tempCollection[i].Title == admin){ //found display name in dropdown
				var intoReview = targetTool === "assignIRBAdmin";
				data = {
					"__metadata": spAppData.__metadata,
					"AssignedIRBAdministratorId": tempCollection[i].Id
				};
				spAppData.AssignedIRBAdministratorId = tempCollection[i].Id;
				if (intoReview)
					data.ApplicationStatus = spAppData.ApplicationStatus = "Under Review";

				// console.log("We want to add: " + admin);
				// insertStudyMember(admin, "RAMS Reviewer", false);

				sendREST("POST", spAppData.__metadata.uri, data, function(){
					sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){	
						var finishUp = function() {
							insertStudyMember(admin, "RAMS Reviewer", false);
							swapToolGenerator(targetTool);
							//saveButton.fadeOut(400, function(){
							// 	saveButton.attr("class", "btn btn-default label-success");
							// 	saveButton.children().attr("class", "glyphicon glyphicon-floppy-saved");
							// }).fadeIn(600);
						};
						if (!intoReview) {
							finishUp();
						} else {
							sendREST("POST", restPath.concat("study/"+assignedID+"/stage/Review"), null, finishUp);
						}
					}, "Merge");
				}, "Merge");
			}
		}
	}


	if((reviewer != null) && (reviewer != "Please Select a Reviewer")){
		if((spAppData.ReviewersId == null) || (reviewerRole == "Primary")){
			currentReviewers = [];
		}else{
			currentReviewers = spAppData.ReviewersId.results;
		}			

		tempCollection = ramsUsers.values();
		for(var i=0; i<tempCollection.length; i++){
			if(tempCollection[i].Title == reviewer){
				
				currentReviewers.push(tempCollection[i].Id);

				if(reviewerRole == "Assigned"){
					data = {
						"__metadata": spAppData.__metadata,
						"ReviewersId": {
							"__metadata": {"type": "Collection(Edm.Int32)"},
							"results": currentReviewers
						}
					}

					spAppData.ReviewersId = {"results": currentReviewers};
				}else if(reviewerRole == "Primary"){
						//console.log("trying to send a primary reviewer: " + currentReviewers);

					data = {
						"__metadata": spAppData.__metadata,
						"PrimaryReviewersId": {
							"__metadata": {"type": "Collection(Edm.Int32)"},
							"results": currentReviewers
						}
					}	

					spAppData.PrimaryReviewersId = {"results": currentReviewers[0]};
				}

				sendREST("POST", spAppData.__metadata.uri, data, function(){
					sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
						insertStudyMember(reviewer, "RAMS Reviewer", false);
						swapToolGenerator("assignApp");
					}, "Merge");
				}, "Merge");
			}
		}
	}

	if((CMOD != null) && (CMOD != "Please Select a Compliant Method of Review") && (CMOD.indexOf("The Current") == -1)){
		for(var i=0; i<7; i++){
			if($("#chkOpt"+i).length){
				if($("#chkOpt"+i).is(':checked'))
					chkBoxesInt += "*";
				else
					chkBoxesInt += "-";
			}
		}

		CMOD += " "+chkBoxesInt;
		data = {
			"__metadata": spAppData.__metadata,
			"ApplicationType": CMOD
		}

		spAppData.ApplicationType = CMOD;
		spAppData.Checkboxes = chkBoxesInt; 
		
		sendREST("POST", spAppData.__metadata.uri, data, function(){
			sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){	
				swapToolGenerator("assignApp");
			}, "Merge");
		}, "Merge");
	}
}

function sendPIReview(){
	var saveButton = $('#saveAdminTool');
	var comment = $('#submissionComment').val();
	data = [];

	var package = {
		"formsID": "250",
		"hyperText": comment + "\n",
		"published": "true",
		"questionsID": "8518",
		"redFlagged": "false"
	}

	data.push(package);

	sendREST("POST", restPath.concat("study/"+assignedID+"/comments/"+targetStage), data, function(){
		swapToolGenerator("studyComments");
	});

};


function removePrimaryReviewer(id){
	data = {
		"__metadata": spAppData.__metadata,
		"PrimaryReviewersId": null
	}

	sendREST("POST", spAppData.__metadata.uri, data, function(){
		sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
			swapToolGenerator("assignApp");
		}, "Merge");
	}, "Merge");
};

function removeAssignedReviewer(id){
	var data;
	var reviewers = [];	

	/*Building new reviewers list, without the one to be removed*/
	for(var i=0; i<spAppData.ReviewersId.results.length; i++){
		if(spAppData.ReviewersId.results[i] != id)
			reviewers.push(spAppData.ReviewersId.results[i]);
	}

	/*packaging new reviewers list*/
	data = {
		"__metadata": spAppData.__metadata,
		"ReviewersId":{
			"__metadata": {"type": "Collection(Edm.Int32)"}, 
			"results": reviewers
		}
	}

	/*updating our local records*/
	spAppData.ReviewersId.results = reviewers;

	/*sending new list to sharepoint*/
	sendREST("POST", spAppData.__metadata.uri, data, function(){
		sendREST("POST", spsubsiteAppData.__metadata.uri, data, function(){
			swapToolGenerator("assignApp");
		}, "Merge");
	}, "Merge");
};

function sendSubmitApp(appStatus, appStage){
	var comments = $('#submissionComment').val();
	var data = [];
	
	var spData ={
		"__metadata": spAppData.__metadata,
		"ApplicationStatus": appStatus
	}

	// XXX What is this hard-coding horror?
	if(comments != null){
		var package = {
			//"formsID": section,
			"formsID": "250",
			"hyperText": comments + "\n",
			"published": "true",
			"questionsID": "8518",
			"redFlagged": "false"
		};
	}

	data.push(package);

	sendREST("POST", spAppData.__metadata.uri, spData, function(){
		sendREST("POST", spsubsiteAppData.__metadata.uri, spData, function(){
			sendREST("POST", restPath.concat("study/"+assignedID+"/stage/"+appStage), null, function(){	
				if(comments != null){
					sendREST("POST", restPath.concat("study/"+assignedID+"/comments/"+(targetStage+1)), data, function(){
			            window.location.href("/sitepages/irb%20applications.aspx");
			           
			        });
				}else{
					window.location.href("/sitepages/irb%20applications.aspx");
				}
			});
		}, "Merge");
	}, "Merge");

};

function publishComments(targetTool){
	var comments = $('#submissionComment').val();
	var data = [];

		var package = {
		//"formsID": section,
		"formsID": "250",
		"hyperText": comments + "\n",
		"published": "true",
		"questionsID": "8518",
		"redFlagged": "false"
	};

	data.push(package);

	sendREST("POST", restPath.concat("study/"+assignedID+"/comments/"+targetStage), data, function(){
        swapToolGenerator(targetTool);
    });
}

function downloadChecklist(relativeUrl){
	var splitAt;

	//console.log("the url is " + relativeUrl);

	splitAt = relativeUrl.split("/");
	relativeUrl = splitAt[1]+"/"+splitAt[2]+"/"+splitAt[3];

	//console.log("the url is " + relativeUrl);

	window.open(siteUrl.concat(relativeUrl));
}

function createLocalEvent(){
	generateAssignedId("Local");
}

function createAdverseEvent(){
	generateAssignedId("Adverse");
}

function createContReview(){
	generateAssignedId("ContReview");
}

function createCloseoutReview(){
	generateAssignedId("Closeout");
}

function createAdminUpdate(){
	generateAssignedId("AdministrativeUpdate");
}

function createAmendment(){
	sendSubmitApp("Awaiting Revisions", "Revision");	
}

function sendReviewChecklist(targetTool, teamFolder){
	var upload = $('#uploadChecklist');

	if(window.FileReader != null){
		fileList = upload[0].files;
		//console.log(fileList);
		for(var i=0; i<fileList.length; i++){
			if(teamFolder == "Study%20Team"){
				fileName = "-CHECKLIST-" + fileList[i].name;
			}else{
				fileName = fileList[i].name;
			}
			
			//console.log("we really want to upload: " + fileName);
			sendFile(fileList[i], fileName, fileList[i].size, teamFolder, function(){
				swapToolGenerator(targetTool);
			});
		}
	}else{
		alert('Please upgrade your browser to upload files.');
	}
}

//this should take in the current facility > then find the committee lookup > then see if this users groups
//match the committee member and irb admins of that site.
function groupCheck(callback){
	var committeeMember = false;
	var irbAdmin = false;
	sendREST("GET", siteUrl.concat("_api/Web/CurrentUser/Groups"), null, function(returnedGroups){
		currentGroups = returnedGroups.d.results;

		for(var i=0; i<currentGroups.length; i++){
			//console.log("you are a part of: " + currentGroups[i].Title);
			if(currentGroups[i].Title.indexOf("Committee Members") > -1){
				committeeMember = true;
			}else if(currentGroups[i].Title.indexOf("IRB Administrator") > -1){
				//console.log("you are an irb admin");
				irbAdmin = true;
			}
		}
		//console.log("sending: committeeMember " + committeeMember + ", irbAdmin " + irbAdmin);
		callback(committeeMember, irbAdmin);
	});
}

/* Grab all local site applications of a parent
 * and update status for each list item
 */
function notifyLocalSitesOnParentStatus(parentId,parentStatus){
    var applicationUrl = siteUrl.concat("_api/web/lists/getbytitle('Application')/items?$filter=ParentStudyID eq '"+parentId+"'"); 
	return $.ajax({
		async: false,
		type: 'GET',
		url: applicationUrl,
		headers: {"accept": "application/json;odata=verbose"},
		dataType: 'json',
		success: function(json){
			updateLocalSiteParentStatus(json, parentStatus);
		},
		error: function(error){alert("Error: "+JSON.stringify(error));}
	});
}

function updateLocalSiteParentStatus (localSites, status){
	
	
	var temp = localSites.d.results;
        	for(var i=0; i<temp.length; i++){
				//alert('temp index is  '+ i);
        		
				//alert (temp[i].ParticipatingSiteId + ' eq' + currentFacility);
				var spData ={
				"__metadata": spAppData.__metadata,
				"ParentStudyStatus": status
				}
				sendREST("POST", temp[i].__metadata.uri, spData, null,"Merge");
        		
        	};
	
}
